#define F_CPU 16000000L
#include <avr/io.h>
#include <util/delay.h>

#define set_bit(value, bit) ( _SFR_BYTE(value) |= _BV(bit) )
#define clear_bit(value, bit) ( _SFR_BYTE(value) &= ~_BV(bit) )

int main(void) {
  int dim = 0;        // 현재 LED 밝기
  int direction = 1;      // 밝기 증가(1) 또는 감소(-1)

  // 파형 출력 핀인 PB7 핀(OC0B 핀)을 출력으로 설정
  set_bit(DDRB, 7);

  // 타이머/카운터 0번을 위상 교정 PWM 모드로 설정
  TCCR0A |= (1 << WGM00);
  TCCR0A |= (1 << COM0A1);    // 비반전 모드
  TCCR0B |= (1 << CS02) | (1 << CS00);  // 분주비를 1024로 설정

  while (1) {
    OCR0A = dim;      // 듀티 사이클 설정
    _delay_ms(10);

    dim += direction;     // 밝기 변화

    if (dim == 0) direction = 1;
    if (dim == 255) direction = -1;
  }

  return 0;
}
