#define F_CPU 16000000L
#include <avr/io.h>
#include <util/delay.h>
#include "UART0.h"
#include "ADC.h"

int main(void) {
  UART0_init();
  ADC_init(1);        // ADC 채널 1번 초기화

  int read, temperature;
  float input_voltage;

  while (1) {
    read = read_ADC();

    // 0에서 1023 사이의 값을 0V에서 5V 사이 값으로 변환
    input_voltage = read * 5.0 / 1023.0;

    // 10mV에 1℃이므로 100을 곱해서 현재 온도 계산
    temperature = (int)(input_voltage * 100.0);

    UART0_print(temperature);
    UART0_write('\n');

    _delay_ms(1000);
  }

  return 0;
}
